.\"
.\"  $Id: Array.n,v 1.3 1994/03/02 01:03:26 dta Exp $
.\"  $Source: /cvs/lib/odmg/Array.n,v $
.\"
.TH Varray Odmg3 "02/06/94" "ODMG-93" "Class Manual"
.SH NAME
Varray \- Dynamic array collection.
.SH SYNOPSIS
#include <Odmg/Array.h>
.SH DESCRIPTION
This collection maintains a dynamic array of elements.
The elements in the array are kept contiguous.
If a element is removed from the middle of the array the rest
of the elements are shifted down so that the empty spot is at
the end of the array.
.SH METHODS
.IP "Varray (Position length, const const int chunk = 10);"
Constructs a virtual array.  The length argument specifies a starting
size for the array.  The length may be zero.  A newly initialized array
will always have a cardinality of 0.
ODMG - the chunk field has been added for performance reasons.
.br
ODMG - Changed argument type from int to Position.
.IP "virtual ~Varray (void);"
Virtual destructor for the dynamic array.  It will not delete its elements.
.IP "Ref<T> operator [] (int);"
Provides for direct access to any element between 0 and cardinality ().
.IP "int query (Ref<Varray <T> > &, const char *fullOQL_predicate) const;"
Not implemented.
.IP "void remove_element_at (int position);"
Removes the element at the specified position.
.IP "void replace_element_at (Ref<T> element, int position);"
Replace the element at the specified position with the new element.
.IP "Ref<T> retrieve_element_at (int position);"
Provides for direct access to any element between 0 and cardinality ().
.IP "void resize (ulong length);"
Set the length of the array.
.br
ODMG - Changed argument type from int to ulong.
.IP "int find_element (Ref<T>) const;"
Locates a element within the array.  Returns -1 if the element is not found.
.br
ODMG - const was added.
.IP "int upper_bound (void) const;"
Returns the current length of the array.
.SH "SEE ALSO"
Odmg (Odmg3)
