/*******************************<+>***************************
 **                             DTA
 *************************************************************
 **
 **  $Id: ListP.h,v 1.6 1994/03/01 23:01:24 dta Exp $
 **
 **  $Source: /cvs/lib/odmg/ListP.h,v $
 **
 **  What @(#):
 **
 **  Author: Dale T. Anderson
 **
 *******************************<+>***************************/
 
#ifndef ListP_h
#define ListP_h

#include <Odmg/Ref.h>

template <class T> class ListNode;

template <class T>
class ListNode
{
	Ref <T> m_ref;

	Ref <ListNode <T> > m_next;
	Ref <ListNode <T> > m_prev;

    public:

	ListNode (T *ref = NULL);
	virtual ~ListNode ();

	Ref <T> get_ref (void) const;
	void set_ref (const Ref <T> &ref);

	Ref <ListNode <T> > get_next_node (void) const;
	Ref <ListNode <T> > get_prev_node (void) const;

	void insert_node (Ref <ListNode <T> > node);
	void append_node (Ref <ListNode <T> > node);

	void remove_node (void);
};

template <class T>
ListNode<T>::ListNode (T *ref) :
    m_ref (ref),
    m_next (this),
    m_prev (this)
{
}

template <class T>
ListNode<T>::~ListNode ()
{
    remove_node ();
    m_next = NULL;
    m_prev = NULL;
}

template <class T>
Ref <T> ListNode <T>::get_ref (void) const
{
    return m_ref;
}

template <class T>
void ListNode <T>::set_ref (const Ref <T> &ref)
{
    m_ref = ref;
}

template <class T>
Ref <ListNode <T> > ListNode <T>::get_next_node (void) const
{
    return m_next;
}

template <class T>
Ref <ListNode <T> > ListNode <T>::get_prev_node (void) const
{
    return m_prev;
}

template <class T>
void ListNode<T>::insert_node (Ref <ListNode <T> > node)
{
    node->m_prev = m_prev;
    node->m_next = this;
    node->m_prev->m_next = node;
    node->m_next->m_prev = node;
}

template <class T>
void ListNode<T>::append_node (Ref <ListNode <T> > node)
{
    node->m_prev = this;
    node->m_next = m_next;
    node->m_prev->m_next = node;
    node->m_next->m_prev = node;
}

template <class T>
void ListNode<T>::remove_node (void)
{
    m_prev->m_next = m_next;
    m_next->m_prev = m_prev;
    m_next = this;
    m_prev = this;
}

#endif
