.\"
.\"  $Id: Odmg.n,v 1.4 1994/03/02 01:03:28 dta Exp $
.\"  $Source: /cvs/lib/odmg/Odmg.n,v $
.\"
.TH Odmg Odmg3 "02/06/94" "ODMG-93" "Class Manual"
.SH INTRODUCTION
This class library is based on the Object Database Management Group - 93
(ODMG-93) book titled \fIThe Object Database Standard.\fR
.IP PROPOSED
.P
Prefix all of the ODMG clases by \fBOdmg\fR or something else that is
unique to preserve the global name space.
.P
It is no longer necessary to have a query method for each derived class
that takes a reference to a collection of the respective type because the
virtual create method allows this functionality to exist in \fICollection\fR.
.P
The \fISet\fR and \fIBag\fR operators can be implemented in the
\fICollection\fR object.
.P
.IP "QUESTIONS for ODMG"
.P
The Ref class is passed by value so there apears to be a lot of
overhead every time it's created and destroyed.  Is this what
was intended?
.P
The collection provides the abstraction necessary for most any type of
container that would be needed.  Both Set and Bag provide characteristics
of a container and not the storage mechanism.  Wouldn't it be better
to move the unique methods and operators for Bag and Set to the collection
and not have these two classes.  Instead the derived classes would provide
a unintelligent storage mechanism and the collection would provide the
characteristics.  Then there would be container classes like Varray, List,
BinaryTree, ...
There would still be needs for search oriented collections like
Index, and HashTable which would add characteristics to one of the
collection types.
.P
A iterator provides the abstraction of position within a collection.
It would be assumed that a iterator and any classes derived from a
collection would have a incestous relationship to provide maximum
performance.  Shouldn't a iterator then have the methods of insert_before,
insert_after, insert_last, and insert_first instead of only in a List?
.P
Should the iterators be managed by a collection so that when a element
is removed from a collection all itertors for that collection could be
notified?
.SH "SEE ALSO"
Ref (Odmg3), Iterator (Odmg3), Collection (Odmg3), Varray (Odmg3), List (Odmg3), Set (Odmg3), Bag (Odmg3)
